import alsaaudio
import numpy
import RPi.GPIO as GPIO
import time

relay = 3
delay = 2.5
nframe  = 500
rate    = 8000
threshold = 20000
devicestr = 'sysdefault:CARD=U0x46d0x821'

lastontime = time.time()
nowon = False
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(relay, GPIO.OUT)
GPIO.output(relay,0)

devices = alsaaudio.pcms(alsaaudio.PCM_CAPTURE)
# print(devices)
pcm = alsaaudio.PCM(type=alsaaudio.PCM_CAPTURE,
                    mode=alsaaudio.PCM_NORMAL,
                    device=devicestr,
                    cardindex=-1)
pcm.setrate(rate)
pcm.setchannels(1)
while True:
    data = pcm.read()
    fdata = numpy.fromstring(data[1],dtype=numpy.int16)
    total = 0L
    for datum in fdata[0:16]:
        total += datum/256*datum/256
    # print(total)
    if total>threshold:
        GPIO.output(relay,1)
        print("On")
        nowon = True
        lastontime = time.time()
    else:
        if time.time()-lastontime>delay and nowon:
            GPIO.output(relay,0)
            nowon = False
            print("Off")
